<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Mendeleiev</title>
</head>
<body>

    <link href="https://fonts.googleapis.com/css?family=Roboto:400,700&display=swap" rel="stylesheet">

    <style>
        * { box-sizing: border-box; outline: 0; }

        body {
            background-image: url(https://upload.wikimedia.org/wikipedia/commons/thumb/8/80/Atom_editor_logo.svg/1118px-Atom_editor_logo.svg.png);
            background-size: auto;
            background-position: center;
            background-repeat: no-repeat;
            background-attachment: fixed;

            max-width: 1200px;
            margin: 0 auto;
        }

        .container {
            display: flex;
            align-content: center;
        }

        #grid {
            display: grid;
            grid-template: repeat(10, 60px) / repeat(18, 60px);
            font-family: 'Roboto', sans-serif;
            margin: 2em auto;
        }

        #grid > .el {
            display: flex;
            flex-direction: column;
            padding: 3px;
        }

        #grid > .el .weight {
            padding-left: 3px;
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
            text-align: right;
        }

        #grid > .el .weight,
        #grid > .el .atomic { font-size: small; }

        #grid > .el .letter {
            font-weight: bold;
            flex: 1;
            align-items: center;
            align-self: center;
            display: flex;
        }

        .color-1 { background: #da627d; }
        .color-2 { background: #e4dfda; }
        .color-3 { background: #c9daea; }
        .color-4 { background: #06d6a0; }
        .color-5 { background: #ffc43d; }
        .color-6 { background: #48a9a6; }
        .color-7 { background: #25ced1; }
        .color-8 { background: #4357ad; }
        .color-9 { background: #7a306c; color: rgba(255,255,255,.8); }
        .color-10 { background: #ab2346; color: rgba(255,255,255,.8); }
    </style>

    <div class="container">
        <div id="grid"></div>
    </div>

    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>

    <script>

        function makeUI(data)
        {
            let grid = document.getElementById('grid');

            data.elements.forEach(element => {

                let e = document.createElement("div");
                e.classList.add("el");
                e.innerHTML = `<div class="weight">${element.atomic_mass}</div>
<div class="letter"><span>${element.symbol}</span></div>
<div class="atomic">${element.number}</div>`;
                e.setAttribute('style',
                    `grid-column-start: ${element.xpos};
grid-column-end: ${element.xpos + 1};
grid-row-start: ${element.ypos};
grid-row-end: ${element.ypos + 1};`);
                e.setAttribute('contenteditable', true);

                if ([3, 11, 19, 37, 55, 87, 119].indexOf(element.number) > -1)
                    e.classList.add("color-1");
                else if ([4, 12, 20, 38, 56, 88].indexOf(element.number) > -1)
                    e.classList.add("color-2");
                else if (element.number >= 21 && element.number <= 30)
                    e.classList.add("color-3");
                else if (element.number >= 39 && element.number <= 48)
                    e.classList.add("color-3");
                else if (element.number >= 72 && element.number <= 80)
                    e.classList.add("color-3");
                else if (element.number >= 104 && element.number <= 112)
                    e.classList.add("color-3");
                else if ([5, 14, 32, 33, 51, 52, 84].indexOf(element.number) > -1)
                    e.classList.add("color-4");
                else if ([13, 31, 49, 50, 81, 82, 83, 113, 114, 115, 116].indexOf(element.number) > -1)
                    e.classList.add("color-5");
                else if ([1, 6, 7, 8, 15, 16, 34].indexOf(element.number) > -1)
                    e.classList.add("color-6");
                else if ([9, 17, 35, 53, 85, 117].indexOf(element.number) > -1)
                    e.classList.add("color-7");
                else if (element.category == "noble gas" || element.number == 118)
                    e.classList.add("color-8");
                else if (element.number >= 57 && element.number <= 71)
                    e.classList.add("color-9");
                else if (element.number >= 89 && element.number <= 103)
                    e.classList.add("color-10");
                grid.appendChild(e);
            });
        }
    
        (function() {
            axios.get("https://raw.githubusercontent.com/raggesilver/Periodic-Table-JSON/master/PeriodicTableJSON.json")
                .then((res) => makeUI(res.data))
                .catch((err) => {
                    window.alert("Could not retrieve PT Json info.");
                    console.error(err);
                });
        })();

    </script>

</body>
</html>